// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2002-2008 - DIGITEO - Claude Gomez
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function r=moyenne_ponderee(x,n,varargin)
  [lhs,rhs]=argn();
  if rhs<>2 then error("La fonction ""moyenne_ponderee"" doit avoir deux arguments."); end
  if type(x)<>1|find(size(x)==1)==[]|type(n)<>1|find(size(n)==1)==[] then
    error("Les arguments de la fonction ""moyenne_ponderee"" doivent tre des vecteurs de nombres.");
  end
  if size(x,"*")<>size(n,"*") then
    error("Les arguments de la fonction ""moyenne_ponderee"" doivent tre des vecteurs de mme dimension.");
  end
  if min(n)<0 then
    error("Le deuxime argument de la fonction ""moyenne_ponderee"" doit tre un vecteur de nombres positifs ou nuls.");
  end
  if sum(n)<%eps then
    error("Le deuxime argument de la fonction ""moyenne_ponderee"" ne doit pas tre le vecteur nul.");
  end
  r=(x*n')/sum(n);
endfunction

