//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2009-2009 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//


function [] = virtualKeyboard()
keyboard = ...
    [ "X", "Y", "Z", "T", "^";
      "==", "(", ")", ",", "/";
      "|", "7", "8", "9", "*";
      "E", "4", "5", "6", "-";
      "=", "1", "2", "3", "+";
      "", "0", ".", "", "Enter"]
buttonSize = [40 40];

[nbLines, nbColumns] = size(keyboard)

f=gcf();
f.axes_size = [nbColumns * buttonSize(1) nbLines * buttonSize(2)];
button = uicontrol("Style", "pushbutton");
for i = 1:nbLines
  for j = 1:nbColumns
    button(i,j) = uicontrol("Style", "pushbutton");
    button(i,j).callback = "keyboardAction("""+keyboard(nbLines - i + 1, j)+""")";
    button(i,j).String = keyboard(nbLines - i + 1, j);
    button(i,j).position = [(j - 1) * buttonSize(1) ...
		   (i - 1) * buttonSize(2) ...
		   buttonSize(1) ...
		   buttonSize(2) ];
  end
end

endfunction